
Core - Bug # 42084

Status: Resolved Priority: Must have
Author: Daniel Alder Category:
Created: 2012-10-17 Assigned To:
Updated: 2013-03-04 Due date:
TYPO3 Version: 4.6
PHP Version:
Complexity:
Is Regression:
Sprint Focus:
Subject: Translation 'en' missing
Description

Since Typo3 4.6 (to 6.0) this line breaks the translation handling:
t3lib\l10n\class.t3lib_l10n_factory.php #90

This is completely wrong 'cause you're never able to translate an english label again.

In theory the 'default' label is not a 'translation'. It's just a placeholder who's telling the translator what the label is standing for (in
english of course). But the 'real' english translation should be in the 'en' translation.

So in fact the 'en' translation in l10n will not be parsed.

Associated revisions
Revision b48bfc9c - 2013-02-14 15:15 - Daniel Alder

[BUGFIX] Allow "en" as language key

Fix a bug which was introduced by #25397 (commit:cb390c79).
If the selected language key is "en", do not override it to "default".
This allows custom updates to translations even for the English language.

Change-Id: I3fcbd35f0144a0cc152acd45d0861d153cc8b495
Resolves: #42084
Related: #25397
Releases: 4.6, 4.7, 6.0, 6.1
Reviewed-on: https://review.typo3.org/17414
Reviewed-by: Oliver Hader
Tested-by: Oliver Hader
Reviewed-by: Xavier Perseguers
Tested-by: Xavier Perseguers

Revision 8df3441a - 2013-02-14 15:22 - Daniel Alder

[BUGFIX] Allow "en" as language key

Fix a bug which was introduced by #25397 (commit:cb390c79).
If the selected language key is "en", do not override it to "default".
This allows custom updates to translations even for the English language.
Change-Id: I3fcbd35f0144a0cc152acd45d0861d153cc8b495
Resolves: #42084
Related: #25397
Releases: 4.6, 4.7, 6.0, 6.1
Reviewed-on: https://review.typo3.org/17414
Reviewed-by: Oliver Hader
Tested-by: Oliver Hader
Reviewed-by: Xavier Perseguers
Tested-by: Xavier Perseguers
Reviewed-on: https://review.typo3.org/18262

Revision 915bf762 - 2013-02-14 15:38 - Xavier Perseguers

[BUGFIX] Allow "en" as language key

Fix a bug which was introduced by #25397 (commit:cb390c79).
If the selected language key is "en", do not override it to "default".
This allows custom updates to translations even for the English language.

Change-Id: I3fcbd35f0144a0cc152acd45d0861d153cc8b495
Resolves: #42084
Related: #25397
Releases: 4.6, 4.7, 6.0, 6.1
Reviewed-on: https://review.typo3.org/18263
Reviewed-by: Xavier Perseguers
Tested-by: Xavier Perseguers

Revision 2c4bffaa - 2013-02-14 15:38 - Xavier Perseguers

[BUGFIX] Allow "en" as language key

Fix a bug which was introduced by #25397 (commit:cb390c79).
If the selected language key is "en", do not override it to "default".
This allows custom updates to translations even for the English language.

Change-Id: I3fcbd35f0144a0cc152acd45d0861d153cc8b495
Resolves: #42084
Related: #25397
Releases: 4.6, 4.7, 6.0, 6.1
Reviewed-on: https://review.typo3.org/18264
Reviewed-by: Xavier Perseguers
Tested-by: Xavier Perseguers

History
#1 - 2012-10-17 22:32 - Xavier Perseguers
- Status changed from New to Needs Feedback

Please describe your use case and tell us why if something is wrong in English we should not change the "placeholder" instead of creating a "real"
English translation.
#2 - 2012-10-18 08:44 - Daniel Alder

Xavier Perseguers wrote:

Please describe your use case and tell us why if something is wrong in English we should not change the "placeholder" instead of creating a "real"
English translation.

For example:
the "default" label in the extension is "label1" an its text "text1" 
the only way to change the label "label1" to "text2" is using TS (whats a bad practise) or change the label within the extension locallang itself in the
"default" section.
reason: the l10n folder is not working anymore for "en" because it will always set to "default". On the other hand "default" is not supported in l10n.
So l10n is totally meaningless for "en" and thats fools you in following situations:
    -  extension is from the communitiy (translations will be overwritten on every update)
    -  if the extension is under version control you have to commit source 'cause of language changes to keep source up-to-date

Or am I missing some kind of alternative to change labels independantly from the extensions source?

Besides:
the translation handling should be simplified/unified/extended. Is there already a discussion running?

#3 - 2012-11-04 21:24 - Xavier Perseguers

Your description makes sense. Could you come up with a patch to remove this line 90. We should test it and make sure existing unit tests still work as
before, and most probably write a few new ones to check the "new" behaviour.

Make sure to think about this way as well:

http://xavier.perseguers.ch/en/tutorials/typo3/articles/managing-localization-files.html

#4 - 2013-01-08 11:58 - Daniel Alder

Ok thanks here it is:
https://review.typo3.org/17414

#5 - 2013-01-09 14:56 - Dmitry Dulepov

plugin.tx_whatever._LOCAL_LANG.default.my_label = Hello, world!

#6 - 2013-01-09 14:57 - Dmitry Dulepov

Needs tests with llxmltranslate and translation server.

#7 - 2013-01-09 16:15 - Daniel Alder

in theory "_LOCAL_LANG.default" works as expected:
it's a fault of the concept 'cause it's overwriting the $this->LOCAL_LANG['default']. So if you don't use an l10n 'en' file labels will be outputted from TS.
But if you are using a l10n 'en' entry the 'en' is the primary key, not 'default' (see $GLOBALS['TSFE']->config['config']['language']). So not the
"_LOCAL_LANG.default" label will be shown but the l10n.

but please visit:
http://wiki.typo3.org/TypoScript_language_additions,_override

It's wrong with or without my patch: [language:default|de|en|...]

Without the patch just 'default' is working not 'en'
With my patch 'en' is working, 'default' not.

So tell me what's correct? And if both 'default' & 'en' should work. Which one is prefered?
I am comming up with a patch if the question will be answerd.

The problem is located in the "pi_loadLL" function.

...something tells me, that the typo3 community has no unit how the translation handling should work. documentation, logic, code and people,
everything is full of contradiction.

wouldn't it be better to start with overthinking the whole translation handling?

#8 - 2013-01-09 16:22 - Daniel Alder

...don't take it personally but:
llxmltranslate is not part of the core.
nobody showed consideration for snowbabel, since this issue breaks it completely.

#9 - 2013-01-10 08:18 - Dmitry Dulepov

Yes, llxmltranslate is not a part of the core but it is the official translation tool for the older versions. So we have to check. And translation server must
still work properly with these changes.

#10 - 2013-02-06 18:53 - Gerrit Code Review
- Status changed from Needs Feedback to Under Review

Patch set 2 for branch master has been pushed to the review server.
It is available at https://review.typo3.org/17414

#11 - 2013-02-07 10:50 - Gerrit Code Review

Patch set 3 for branch master has been pushed to the review server.
It is available at https://review.typo3.org/17414

#12 - 2013-02-14 15:09 - Xavier Perseguers

Dmitry Dulepov wrote:
Yes, llxmltranslate is not a part of the core but it is the official translation tool for the older versions. So we have to check. And translation server
must still work properly with these changes.

No problem with the translation server. Translation server (pootle) is working with a "template" source language which is "English" for us and then can
translate in other languages. English as se never appears.

We are changing the behaviour of TYPO3 starting from 4.6, so for older versions, there is no side-effect.

#13 - 2013-02-14 15:18 - Gerrit Code Review

Patch set 1 for branch TYPO3_6-0 has been pushed to the review server.
It is available at https://review.typo3.org/18262

#14 - 2013-02-14 15:20 - Gerrit Code Review

Patch set 1 for branch TYPO3_4-7 has been pushed to the review server.
It is available at https://review.typo3.org/18263

#15 - 2013-02-14 15:22 - Gerrit Code Review

Patch set 1 for branch TYPO3_4-6 has been pushed to the review server.
It is available at https://review.typo3.org/18264

#16 - 2013-02-14 15:30 - Daniel Alder
- Status changed from Under Review to Resolved
- % Done changed from 0 to 100

Applied in changeset commit:8df3441a757f2aa5c10348ca432bcc98f565e448.

#17 - 2013-03-04 20:16 - Gerrit Code Review
- Status changed from Resolved to Under Review

Patch set 1 for branch master_new has been pushed to the review server.
It is available at https://review.typo3.org/18653

#18 - 2013-03-04 21:04 - Christian Kuhn
- Status changed from Under Review to Resolved
